--------------------------------------------------------------------------
--  DLX PROCESSOR MODEL SUITE
--  Copyright (C) 1995, Martin Gumm
--  University of Stuttgart / Department of Computer Science / IPVR-ISE
--------------------------------------------------------------------------
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 1, or (at your option)
--  any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--------------------------------------------------------------------------
--  Last revision date : November 15 1995
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  *** SYNOPSYS synthesizable code (ver. 3.2.a) ***
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  Dataflow descrition of the transparent latch (32-bit)
--  
--  (file reg_addr_latch-dataflow.vhd)
--------------------------------------------------------------------------

architecture dataflow of latch is

signal master : std_logic;
signal slave  : std_logic;

begin 

  lat : process (latch_en, d)
  begin

    if latch_en = '0' then
      master <= d after tpd_latch;
    end if;

    if latch_en = '1' then
      slave <= master after tpd_latch;
    end if;

  end process lat;

  q <= slave after tpd_latch;

end dataflow;



